EggCollector ={
  _VERSION = 'EggCollector.lua 1.0.0',
  _URL     = 'http://www.modhoster.de',
  _DESCRIPTION = 'egg collecting crew for Farming Simulator 15',
  _LICENSE = [[
    MIT LICENSE

    Copyright (c) 2015 Eisbearg

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the
    "Software"), to deal in the Software without restriction, including
    without limitation the rights to use, copy, modify, merge, publish,
    distribute, sublicense, and/or sell copies of the Software, and to
    permit persons to whom the Software is furnished to do so, subject to
    the following conditions:

    The above copyright notice and this permission notice shall be included
    in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
    OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ]]
}




source(Utils.getFilename("inspect.lua", g_currentModDirectory.."scripts"))




--EggCollector = {};
EggCollector_mt = Class(EggCollector, Placeable);
InitObjectClass(EggCollector, "EggCollector");


function EggCollector:new(isServer, isClient, customMt)
	local self = Placeable:new(isServer, isClient, EggCollector_mt);
    registerObjectClassName(self, "EggCollector");
	
	return self;
end;


function EggCollector:delete()
	unregisterObjectClassName(self);
	EggCollector:superClass().delete(self);
end;


function EggCollector:deleteFinal()
	EggCollector:superClass().deleteFinal(self);
end;


function EggCollector:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
	if not EggCollector:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
		return false;
    end;
	
	if not moveMode then
		self.DEBUG = false
		local xmlFile = loadXMLFile("TempXML", xmlFilename);
		self.updateWaitSeconds = getXMLInt(xmlFile, "placeable.sleepTimeSeconds")
		self.updateWaitDT = 0;
		delete(xmlFile);
	end
  
	return true;
end;


function EggCollector:update(dt) -- dt is milliSeconds
	-- according to the number of eggs to search, we do this just sometimes (let the chicks work, first)
	self.updateWaitDT = self.updateWaitDT - dt;
	if self.updateWaitDT > 0 then return end;
	self.updateWaitDT = self.updateWaitSeconds * 1000;

	-- do egg checking	
	local ObjectsID = g_currentMission.husbandries.chicken.pickupObjectsId
	local Num = getNumOfChildren(ObjectsID)
	if self.DEBUG then print("EggCollector: eggs to check = "..tostring(Num)); end;
	for i = 1, Num - 1 do
		local childID = getChildAt(ObjectsID, i);
		if childID ~= nil and childID ~= 0 then
			if getVisibility(childID) then
				local triggerID = getChildAt(childID,0);
				if self.DEBUG then print("EggCollector: moving to knapsack egg id = "..tostring(childID).." id = "..tostring(triggerID)); end;
				g_currentMission.husbandries.chicken.pickupObjectTriggerCallback(g_currentMission.husbandries.chicken, triggerID, g_currentMission.player.rootNode, true, false, false, g_currentMission.player.rootNode, -1);
				g_currentMission.husbandries.chicken.pickupObjectTriggerCallback(g_currentMission.husbandries.chicken, triggerID, g_currentMission.player.rootNode, false, true, false, g_currentMission.player.rootNode, -1);
			end;
		end;
	end;
end;


registerPlaceableType("EggCollector", EggCollector);
				